/*
 * UART0.h
 *
 * Created: 13.3.2012 15:57:25
 *  Author: adam
 *
 *  Hlavikov soubor pro ovldn seriovho kanlu 0, kter bude pouit pro ovldn GPSky
 *
 *	Nastaven:	9600 baud
 *				8 data bit
 *				1 stop bit
 */ 

#ifndef UART0_H_
	#define UART0_H_

	#define BAUD0 9600
	#define SPEED0 ((F_CPU/BAUD0/16)-1) 
	
	BYTE RXreturn0 = 0;
	BYTE RXcheck0 = 0;
	BYTE received0;

	void serial_0_init(BYTE);
	BYTE serial_0_read();
	void serial_0_write(BYTE);

	void serial_0_init(BYTE speed)
	{
		UCSR0B = (1<<RXCIE0)|(1<<RXEN0)|(1<<TXEN0);		// Rx int enable ; RX enable ; TX enable
		UCSR0C = (1<<UCSZ01)|(1<<UCSZ00);				// 8bit ; 1 stop ; no parity
		UBRR0L = speed;
	}
	
	void serial_0_write(BYTE data)
	{
		while( !(UCSR0A & (1<<UDRE)) ) {}	// wait until buffer isn't empty
			UDR0 = data;		
	}
	
	BYTE serial_0_read()
	{
		while( !(UCSR0A & (1<<RXC)) ) {}	// wait until buffer isn't full
			return UDR0;		
	}

	ISR(USART0_RX_vect)
	{
		RXreturn0 = UDR0;
		RXcheck0 = 1;
		return;		
	}

#endif /* UART0_H_ */