/*
 * UART1.h
 *
 * Created: 13.3.2012 16:18:20
 *  Author: adam
 *
 *  Hlavikov soubor pro ovldn seriovho kanlu 1, kter bude pouit pro komunikaci s masterem
 *
 *	Nastaven:	57600 baud
 *				8 data bit
 *				1 stop bit
 */ 

#ifndef UART1_H_
#define UART1_H_

	#define BAUD1 57600
	#define SPEED1 ((F_CPU/BAUD1/16)-1) 
	
	BYTE RXreturn1 = 0;
	BYTE RXcheck1 = 0;

	void serial_1_init(BYTE);
	BYTE serial_1_read();
	void serial_1_write(BYTE);
	void serial_1_print(BYTE);
	void serial_1_data_to_pc(WORD16, WORD16, WORD16, WORD16, BYTE , BYTE, BYTE);

	void serial_1_init(BYTE speed)
	{
		UCSR1B = (1<<RXCIE1)|(1<<RXEN1)|(1<<TXEN1); // Rx int enable ; RX enable ; TX enable
		UCSR1C = (1<<UCSZ11)|(1<<UCSZ10); // 8bit ; 1 stop ; no parity
		UBRR1L = speed;
	}
	
	void serial_1_write(BYTE data)
	{
		while( !(UCSR1A & (1<<UDRE)) ) {}	// wait until buffer isn't empty
			UDR1 = data;		
	}
	
	BYTE serial_1_read()
	{
		while( !(UCSR1A & (1<<RXC)) ) {}	// wait until buffer isn't full
			return UDR1;		
	}

	ISR(USART1_RX_vect)
	{
		RXreturn1 = UDR1;
		RXcheck1 = 1;
		if(RXreturn1 == 0)
			asm("jmp 0");	
		return;		
	}

	void serial_1_print(BYTE data)
	{
		lcd_gotoxy(7,2);
		lcd_putc(data);
	}
	
	void serial_1_data_to_pc(WORD16 d_left, WORD16 d_center, WORD16 d_right, WORD16 azimuth, BYTE course, BYTE gear, BYTE strip) // send course, gearbox,3 distances in BCD
	{
		BYTE distance_left_ASCII[3];
		BYTE distance_center_ASCII[3];
		BYTE distance_right_ASCII[3];
		BYTE azimuth_ASCII[3];
		BYTE A;
		WORD16 B;
		
		// LEFT //
		if(d_left != NO_OBJECT || d_left != ERROR)
		{
			A = d_left;
			distance_left_ASCII[0] = A/100;
			A = A - distance_left_ASCII[0] * 100;
			distance_left_ASCII[1] = A/10;
			A = A - distance_left_ASCII[1] * 10;
			distance_left_ASCII[2] = A;
		
			distance_left_ASCII[0] = distance_left_ASCII[0] + 48;
			distance_left_ASCII[1] = distance_left_ASCII[1] + 48;
			distance_left_ASCII[2] = distance_left_ASCII[2] + 48;
		}
		if(d_left == NO_OBJECT)
		{
			distance_left_ASCII[0] = 'N';
			distance_left_ASCII[1] = '/';
			distance_left_ASCII[2] = 'A';
		}
		if(d_left == ERROR)
		{
			distance_left_ASCII[0] = 'E';
			distance_left_ASCII[1] = 'E';
			distance_left_ASCII[2] = 'E';
		}
		// CENTER //
		if(d_center != NO_OBJECT || d_center != ERROR)
		{
			A = d_center;
			distance_center_ASCII[0] = A/100;
			A = A - distance_center_ASCII[0] * 100;
			distance_center_ASCII[1] = A/10;
			A = A - distance_center_ASCII[1] * 10;
			distance_center_ASCII[2] = A;	
		
			distance_center_ASCII[0] = distance_center_ASCII[0] + 48;
			distance_center_ASCII[1] = distance_center_ASCII[1] + 48;
			distance_center_ASCII[2] = distance_center_ASCII[2] + 48;
		}
		if(d_center == NO_OBJECT)
		{
			distance_center_ASCII[0] = 'N';
			distance_center_ASCII[1] = '/';
			distance_center_ASCII[2] = 'A';
		}
		if(d_center == ERROR)
		{
			distance_center_ASCII[0] = 'E';
			distance_center_ASCII[1] = 'E';
			distance_center_ASCII[2] = 'E';
		}
		// RIGHT //
		if(d_right != NO_OBJECT || d_right != ERROR)
		{
			A = d_right;
			distance_right_ASCII[0] = A/100;
			A = A - distance_right_ASCII[0] * 100;
			distance_right_ASCII[1] = A/10;
			A = A - distance_right_ASCII[1] * 10;
			distance_right_ASCII[2] = A;
			
			distance_right_ASCII[0] = distance_right_ASCII[0] + 48;
			distance_right_ASCII[1] = distance_right_ASCII[1] + 48;
			distance_right_ASCII[2] = distance_right_ASCII[2] + 48; 
		}
		if(d_right == NO_OBJECT)
		{
			distance_right_ASCII[0] = 'N';
			distance_right_ASCII[1] = '/';
			distance_right_ASCII[2] = 'A';
		}
		if(d_right == ERROR)
		{
			distance_right_ASCII[0] = 'E';
			distance_right_ASCII[1] = 'E';
			distance_right_ASCII[2] = 'E';
		}
		
		// AZIMUTH //
		
		B = azimuth;
		azimuth_ASCII[0] = (BYTE)(B/1000);
		B = B - azimuth_ASCII[0] * 1000;
		azimuth_ASCII[1] = (BYTE)(B/100);
		B = B - azimuth_ASCII[1] * 100;
		azimuth_ASCII[2] = (BYTE)B/10;
			
		azimuth_ASCII[0] = azimuth_ASCII[0] + 48;
		azimuth_ASCII[1] = azimuth_ASCII[1] + 48;
		azimuth_ASCII[2] = azimuth_ASCII[2] + 48; 
		
		// STRIP //
		
		strip += 48;
		
		cli();
		serial_1_write(course);
		serial_1_write(gearbox);
		serial_1_write(distance_left_ASCII[0]);
		serial_1_write(distance_left_ASCII[1]);
		serial_1_write(distance_left_ASCII[2]);
		serial_1_write(distance_center_ASCII[0]);
		serial_1_write(distance_center_ASCII[1]);
		serial_1_write(distance_center_ASCII[2]);
		serial_1_write(distance_right_ASCII[0]);
		serial_1_write(distance_right_ASCII[1]);
		serial_1_write(distance_right_ASCII[2]);	
		serial_1_write(azimuth_ASCII[0]);
		serial_1_write(azimuth_ASCII[1]);
		serial_1_write(azimuth_ASCII[2]);
		serial_1_write(strip);
		sei();
	}
	
#endif /* UART1_H_ */