/*
 * compass.h
 *
 * Created: 13.3.2012 17:20:50
 *  Author: adam
 *
 * Ovlada pro zen elektronickho kompasu po I2C
 * 
 * Include soubor je uren pro procesor ATmega128 s I2C sbrnic na pinech PD0 a PD1
 *
 */ 


#ifndef COMPASS_H_
	#define COMPASS_H_

	#define Dev24C04  0xe0 // // 24C04 - type of eeprom ... adress of compass on I2C bus
	#define DECLINATION 0 

	void compas_init(WORD16);
	void compas_reset();
	WORD16 compas_measure();
	void compas_print(WORD16);
	
	void compas_init(WORD16 declin)
	{
		i2c_start_wait(Dev24C04+I2C_WRITE);
		i2c_write(0x03);	
		i2c_write(declin>>8);
		i2c_stop();	
		i2c_start_wait(Dev24C04+I2C_WRITE);
		i2c_write(0x04);	
		i2c_write(declin);
		i2c_stop();	
	}
	
	void compas_reset()
	{
		i2c_start_wait(Dev24C04+I2C_WRITE);
		i2c_write(0x00);	
		i2c_write(0xA0);
		i2c_write(0xAA);
		i2c_write(0xA5);
		i2c_write(0xC5);
		i2c_stop();		
	}
	
	WORD16 compas_measure()
	{
		BYTE cmps_angle_low;
		BYTE cmps_angle_high;	
		WORD16 i;
		WORD16 angle[4];
		
		for(i = 0 ; i < 3 ; i++)
		{
			i2c_start_wait(Dev24C04+I2C_WRITE);	// open communication with adress of device in write mode
			i2c_write(0x00);					
			i2c_write(0x31);					// write command
		  
			i2c_stop(); 
			
			i2c_start_wait(Dev24C04+I2C_WRITE);	// write adress in memory
			i2c_write(0x01);
			i2c_start_wait(Dev24C04+I2C_READ);
			cmps_angle_high = i2c_readNak();                    
			i2c_stop();
			
			i2c_start_wait(Dev24C04+I2C_WRITE);
			i2c_write(0x02);
			i2c_start_wait(Dev24C04+I2C_READ);
			cmps_angle_low = i2c_readNak();     // read one byte from EEPROM
			i2c_stop();
			angle[i] = 0;
			angle[i] = cmps_angle_high*255 + cmps_angle_low;
		}		
		
		angle[3] = (angle[0] + angle[1] + angle[2]) / 3;
		return angle[3];
	}
	
	void compas_print(WORD16 angle)
	{
		lcd_gotoxy(16,2);
		lcd_write_int(angle/10,3);		
	}
	
#endif /* COMPASS_H_ */