/*
 * engines.h
 *
 * Created: 13.3.2012 17:41:48
 *  Author: adam
 *
 * Driver pro ovldn motor pomoc H-mstku
 *
 */ 


#ifndef ENGINES_H_
	#define ENGINES_H_

	#define FORWARD 0x1B	// 00011011b - X X DB2 DA2 E2 DB1 DA1 E1 - oba motory vpred
	#define BACK 0x2D		// 00101101b
	#define LEFT 0x1D		// 00101011b - 
	#define RIGHT 0x2B		// 00011101b -  
	#define STOP 0x00       // zastavit
	
	#define COURSE_LEFT '4'
	#define COURSE_FRONT '8'
	#define COURSE_RIGHT '6'
	#define COURSE_BACK '2'
	#define COURSE_HOLD '5'
	
	#define ENGINE_PORT PORTC
	#define ENGINE_DDR DDRC
	
	BYTE gearbox = 'A';
	BYTE engines_counter;
	BYTE stripping = 0;		// promenna udavaj=ic=i pom2r rychlosti ps
	BYTE stripping_counter = 0;  // promenna na picotani cyklu
	BYTE mask = 0xFF;

/*
		0 ... oba pasy stejne rzchle
		1 ... levy 3, pravy 4		// lekko do lewa
		3 ... levy 2, pravy 4		// srednio do lewa
*/

	void engines_init();	// initialize TIMER0
	void engines(BYTE);		// set couse of vehicle
	void engines_gearbox_print(BYTE);
	void engines_course_print(BYTE);
	
	void engines_init()
	{
		TCCR0 = (1 << CS02) | (0 << CS01) | (1 << CS00);	// set F_CPU/1024
		TIMSK = (1 << TOIE0);	//enable overflow interrupt
		TCNT0 = 0x00;	// reset register value
		gearbox = 'A';	// set engines for max speed
	}
	
	void engines(BYTE course)
	{
		if(course == 0x00)
			return;
		
		if(course == '8')
			ENGINE_PORT = FORWARD;
		
		if(course == '2')
			ENGINE_PORT = BACK;
			
		if(course == '6')
			ENGINE_PORT = LEFT;
			
		if(course == '4')
			ENGINE_PORT = RIGHT;
			
		if(course == '5')
			ENGINE_PORT = STOP;
	}
	
	ISR (TIMER0_OVF_vect)
	{
		switch(stripping)		// vztvoreni masky pro DDRC
		{
			case 0:
				mask = 0xFF;	
				break;
				
			case 1:
				if(stripping_counter == 0)
					mask = 0x07;
				else
					mask = 0xFF;
				break;	
			
			case 3:
				if(stripping_counter == 0)
					mask = 0x38;
				else
					mask = 0xFF;
				break;
		}
		if(++stripping_counter == 4)
			stripping_counter = 0;
		
		if(gearbox == 'A')	//  4/4
			ENGINE_DDR = 0xFF & mask;
			
		if(gearbox == 'B')	//	3/4
		{
			if(engines_counter <= 2)
				ENGINE_DDR = 0xFF & mask;
			else
				ENGINE_DDR = 0x00;						
		}
		
		if(gearbox == 'C')	//	2/4
		{
			if(engines_counter <= 1)
				ENGINE_DDR = 0xFF & mask;
			else
				ENGINE_DDR = 0x00;						
		}
		
		if(gearbox == 'D')	//	1/4
		{
			if(engines_counter == 0)
				ENGINE_DDR = 0xFF & mask;
			else
				ENGINE_DDR = 0x00;						
		}	
		
		engines_counter++;	
		if(engines_counter == 4)	// reset
			engines_counter = 0;	
			
		// VEKTOR PRETECENI CASOVACE 2 //	
		if(blik++ == 5)
		{
			if( !(BLIK_PORT &(1 << BLIK_P)) )
				PORTF = (1 << BLIK_P);
			else
				PORTF = (0 << BLIK_P);
			blik = 0;
		}	
		/////////////////////////////////
	}

	void engines_gearbox_print(BYTE gear)
	{
		lcd_gotoxy(12,1);
		lcd_putc(gear);
	}
	
	void engines_course_print(BYTE course)
	{
		lcd_gotoxy(5,1);
		lcd_putc(course);
	}

#endif /* ENGINES_H_ */