/*
 * keyboard.h
 *
 * Created: 13.3.2012 16:34:20
 *  Author: adam
 *
 * Driver pro ovldn klavesnice 4x4
 *
 *	1	2	3	A
 *	4	5	6	B
 *	7	8	9	C
 *	*	0	#	D
 *
 */ 


#ifndef KEYBOARD_H_
	#define KEYBOARD_H_
	
	#define KEY_PORT PORTB
	#define KEY_DDR DDRB
	#define KEY_PIN PINB
	#define KEY_P4 PB4
	#define KEY_P5 PB5
	#define KEY_P6 PB6
	#define KEY_P7 PB7	
	
	BYTE keyboard();
	void keyboard_print(BYTE);
	
	BYTE keyboard()
	{
		KEY_DDR = 0x0F;	//  lover half of portB is set like output
		
		KEY_PORT = 0xFE;	
			if( !(KEY_PIN &(1 << KEY_P4)) )	// if PB4 is low
				return '1';
			if( !(KEY_PIN &(1 << KEY_P5)) )
				return '4';
			if( !(KEY_PIN &(1 << KEY_P6)) )
				return '7';
			if( !(KEY_PIN &(1 << KEY_P7)) )
				return '*';	
		
		KEY_PORT = 0xFD;
			if( !(KEY_PIN &(1 << KEY_P4)) )
				return '2';
			if( !(KEY_PIN &(1 << KEY_P5)) )
				return '5';
			if( !(KEY_PIN &(1 << KEY_P6)) )
				return '8';
			if( !(KEY_PIN &(1 << KEY_P7)) )
				return '0';	
		
		KEY_PORT = 0xFB;
			if( !(KEY_PIN &(1 << KEY_P4)) )
				return '3';
			if( !(KEY_PIN &(1 << KEY_P5)) )
				return '6';
			if( !(KEY_PIN &(1 << KEY_P6)) )
				return '9';
			if( !(KEY_PIN &(1 << KEY_P7)) )
				return '#';	
		
		KEY_PORT = 0xF7;
			if( !(KEY_PIN &(1 << KEY_P4)) )
				return 'A';
			if( !(KEY_PIN &(1 << KEY_P5)) )
				return 'B';
			if( !(KEY_PIN &(1 << KEY_P6)) )
				return 'C';
			if( !(KEY_PIN &(1 << KEY_P7)) )
				return 'D';
				
			return 0x00;
	}
	
	void keyboard_print(BYTE key)
	{
		if(key)
		{
	    	lcd_gotoxy(18,1);
	    	lcd_putc(key);
	    }
	    else
	    {
	    	lcd_gotoxy(18,1);
	    	lcd_putc(' ');
	    }		
	}
	
#endif /* KEYBOARD_H_ */