/*
 * Aplikace_5.c
 *
 * Created: 13.3.2012 15:47:44
 *  Author: adam
 *
 *	5. revizn verze programu
 *  V tto verzi dojde k pepracovn vech hlavikovch soubor do jednotn formy
 *  a do pepracovn kdu do siln typov formy
 * 
 */ 

#define F_CPU 16000000

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>

typedef unsigned char BYTE;
typedef unsigned short int WORD16;
typedef unsigned long int WORD32;
typedef signed short int SWORD16;

#include "lcd.h"
#include "keyboard.h"
#include "twi_lib.h"
#include "compass.h"
#include "blikac.h"
#include "engines.h" // not meen tested
#include "ultra_sonic.h"
#include "UART0.h"
#include "UART1.h"

int main(void)
{
	BYTE data = 0;
	BYTE key = 0;
	BYTE course = '8';
	WORD16 angle = 0;
	WORD16 d_left = 0;
	WORD16 d_center = 0;
	WORD16 d_right = 0;
	BYTE random_num;
	BYTE check_r = 1;
	BYTE couvej;
	BYTE temp;
	SWORD16 cil[4];
	SWORD16 diference;
	BYTE i;
	
	serial_1_init(SPEED1);
	//serial_0_init(SPEED0);
	lcd_init(LCD_DISP_ON);
	i2c_init();
	compas_init(DECLINATION);
	engines_init();
	//blik_init();   // viz blikac.h
	
	lcd_gotoxy(0,0);
	lcd_puts("  Robot DELUXE 2.0  ");
	lcd_gotoxy(0,1);
	lcd_puts(" Wait for start mark");
	lcd_gotoxy(0,2);
	lcd_puts("   1) Manual mode   ");
	lcd_gotoxy(0,3);
	lcd_puts("   2) Autonome modei");
	
	sei();
	BYTE check = 1;
	while(check == 1)
	{
		key = keyboard();
		
		if( (RXcheck1 != 0 && (RXreturn1 == '1' || RXreturn1 == '2' || RXreturn1 == '3' || RXreturn1 == '4') ))
			check = 0;
	}

	if(RXreturn1 == '1' || key == '1') // MODE 1 ( MANUAL MODE ) // jednoduchy mod ovldn z potae
	{		
		lcd_gotoxy(0,0);					// poaten inicializace displaye
		lcd_puts("  Robot DELUXE 2.0  ");
		lcd_gotoxy(0,1);
		lcd_puts("smer:X rych:X kla:X "); // smer (5,1) , rych (12,1), kla(18,1)
		lcd_gotoxy(0,2);
		lcd_puts("  COM: X  azim: XXX "); // COM (7,2) azimut(16,2)
		lcd_gotoxy(0,3);
		lcd_puts("d1:    d2:    d3:   "); // di(3,3), d2(10,3), d3(17,3)
		RXreturn1 = '5';
	
		while(1)		// nekonen smyka vlastnho programu
		{
			 if(RXcheck1)
		    {
				data = RXreturn1;
		    	RXcheck1 = 0;
		    	
		    	if(RXreturn1 >= 'A' && RXreturn1 <= 'D')
		    		gearbox = RXreturn1;
		    	if(RXreturn1 == '2' || RXreturn1 == '4' || RXreturn1 == '5' || RXreturn1 == '6' || RXreturn1 == '8')
		    		course = RXreturn1;
				if(RXreturn1 == '1' || RXreturn1 == '3' || RXreturn1 == '0')
					stripping = RXreturn1-48;
		    }
			
			key = keyboard();
			
			if(key >= 'A' && key <= 'D') // A B C D
		    	gearbox = key;
		    if(key == '2' || key == '4' || key == '5' || key == '6' || key == '8')
		    	course = key; 		
			if(key == '1' || key == '3' || key == '0')
					stripping = key-48;
			
			d_left = distance_measure_left();		// men dat
			d_center = distance_measure_center();
			d_right = distance_measure_right();
			angle = compas_measure();
			engines(course);				// nastaven motoru
			
			distance_print(d_left,d_center,d_right);	// vytisknut dat na display
			compas_print(angle);
			engines_course_print(course);
			engines_gearbox_print(gearbox);
			keyboard_print(key);
			serial_1_print(data);
			
			serial_1_data_to_pc(d_left,d_center,d_right,angle,course,gearbox,stripping);	// zasln dat do PC

			_delay_ms(10);
			
		}
    }
	
	if(RXreturn1 == '2' || key == '2') // MODE 1 ( MANUAL MODE ) // mod samostatnho vyhbn se pekkm
	{
		gearbox = 'C';
		
		lcd_gotoxy(0,0);					// po=aten inicializace dispalye
		lcd_puts("  Robot DELUXE 2.0  ");
		lcd_gotoxy(0,1);
		lcd_puts("smer:X rych:X kla:X "); // smer (5,1) , rych (12,1), kla(18,1)
		lcd_gotoxy(0,2);
		lcd_puts("  COM: X  azim: XXX "); // COM (7,2) azimut(16,2)
		lcd_gotoxy(0,3);
		lcd_puts("d1:    d2:    d3:   "); // di(3,3), d2(10,3), d3(17,3)
		RXreturn1 = '5';
		
		while(1)		// vlastn smyka programu
		{
			d_left = distance_measure_left();	// pomr veliin
			d_center = distance_measure_center();
			d_right = distance_measure_right();
			angle = compas_measure();
			
			if(check_r == 1)   // mean, that new random number is needed
	    	{
	    		random_num = (BYTE)rand() / 128; // give 1 or 0 by 50% probability
	    		check_r = 0;  // random number has been generated
	    	}	
			
			if(d_center >= 25)	// cesta je voln
			{
				course = COURSE_FRONT;
				engines(course);
				couvej = 1;
	    		check_r = 1;		// mean that new random number can be prepared
	    		if(d_left < 15)		// drobn pekka na levo
				{
	    			course = COURSE_RIGHT;
					engines(course);
					lcd_gotoxy(10,2);
	    			lcd_write_int(2,1);
				}
				if(d_right < 15)	// drobn pekka na pravo
				{
	    			course = COURSE_LEFT;
					engines(course);
					lcd_gotoxy(10,2);
	    			lcd_write_int(3,1);
				}
			}
	    	else	// pekka na cest
			{
				if( (d_left  >= 25) && (d_left >= d_right))		// v levo je misto
				{
					temp = 1;
					while(temp == 1)
					{
						d_left = distance_measure_left();
						d_center = distance_measure_center();
						d_right = distance_measure_right();
						angle = compas_measure();		
						course = COURSE_LEFT;
						lcd_gotoxy(10,2);
	    				lcd_write_int(4,1);	
						engines(course);
						
						if(d_center > 40)		
						{						
	    				    temp = 0;		
						}
						distance_print(d_left,d_center,d_right);
						compas_print(angle);
						engines_course_print(course);
						engines_gearbox_print(gearbox);
						keyboard_print(key);
						serial_1_print(data);
						
						serial_1_data_to_pc(d_left,d_center,d_right,angle,course,gearbox,stripping);
						_delay_ms(10);
					}												
				}
				else		 // vlevo misto neni, jede se v pravo
				{
					if(d_right >= 25)
					{
						temp = 1;
						while(temp == 1)
						{
							d_left = distance_measure_left();
							d_center = distance_measure_center();
							d_right = distance_measure_right();
							angle = compas_measure();		
							course = COURSE_RIGHT;
							lcd_gotoxy(10,2);
	    					lcd_write_int(4,1);	
							engines(course);
							
							if(d_center > 40)		
							{						
	    					    temp = 0;		
							}
							distance_print(d_left,d_center,d_right);
							compas_print(angle);
							engines_course_print(course);
							engines_gearbox_print(gearbox);
							keyboard_print(key);
							serial_1_print(data);
							
							serial_1_data_to_pc(d_left,d_center,d_right,angle,course,gearbox,stripping);
							_delay_ms(10);	
						}
					}
					else	// vlevo je dost mista
					{
						temp = 1;
						if(random_num == 0)
						{
							while(temp == 1)
							{
								d_left = distance_measure_left();
								d_center = distance_measure_center();
								d_right = distance_measure_right();
								angle = compas_measure();
								
								if(d_center < 40 && couvej == 1)
								{
									course = COURSE_BACK;
									engines(course);
									lcd_gotoxy(10,2);
	    							lcd_write_int(6,1);
								}
								else
								{
									course = COURSE_LEFT;
									engines(course);
									lcd_gotoxy(10,2);
	    							lcd_write_int(7,1);
									couvej = 0;
									if(d_center > 50)
									{
	    								temp = 0;			
									}	
								}
								engines(course);
								
								distance_print(d_left,d_center,d_right);
								compas_print(angle);
								engines_course_print(course);
								engines_gearbox_print(gearbox);
								keyboard_print(key);
								serial_1_print(data);
								
								serial_1_data_to_pc(d_left,d_center,d_right,angle,course,gearbox,stripping);
								_delay_ms(10);
							}
						}
						else
						{
							while(temp == 1)
							{
								d_left = distance_measure_left();
								d_center = distance_measure_center();
								d_right = distance_measure_right();
								angle = compas_measure();
								
								if(d_center < 40 && couvej == 1)
								{
									course = COURSE_BACK;
									engines(course);
									lcd_gotoxy(10,2);
	    							lcd_write_int(8,1);
								}
								else
	    						{
	    							course = COURSE_RIGHT;
									engines(course);
									lcd_gotoxy(10,2);
	    							lcd_write_int(9,1);
									couvej = 0;
	    							if(d_center > 50)
									{
	    								temp = 0;			
									}																							
	    						}
								
								distance_print(d_left,d_center,d_right);
								compas_print(angle);
								engines_course_print(course);
								engines_gearbox_print(gearbox);
								keyboard_print(key);
								serial_1_print(data);
								
								serial_1_data_to_pc(d_left,d_center,d_right,angle,course,gearbox,stripping);
								_delay_ms(10);
							}
						}
					}
				}
			}
			
			distance_print(d_left,d_center,d_right);
			compas_print(angle);
			engines(course);
			engines_course_print(course);
			engines_gearbox_print(gearbox);
			keyboard_print(key);
			serial_1_print(data);
			
			serial_1_data_to_pc(d_left,d_center,d_right,angle,course,gearbox,stripping);
			_delay_ms(10);
		}
	}
	
	if(RXreturn1 == '3' || key == '3') // MODE 3 ( Azimuth mode ) // jede na uren cl
	{
		gearbox = 'C';	// rzchlost prevodovky
		
		
		check = 1;
		lcd_gotoxy(0,0); lcd_puts("                    ");
		lcd_gotoxy(0,1); lcd_puts("                    ");
		lcd_gotoxy(0,2); lcd_puts("                    ");
		lcd_gotoxy(0,3); lcd_puts("                    ");
		RXreturn1 = '5';
		i = 0;
		RXcheck1 = 0;
		
		while(check)	// sekvence nacteni kurzu
		{
			lcd_gotoxy(4,1);
			lcd_puts("Put azimuth :");
			lcd_gotoxy(8,2);
			lcd_puts("___");
			while(i < 3)
			{
				if(RXcheck1)
				{
					cil[i] = RXreturn1;
					lcd_gotoxy(i+8,2);
					lcd_putc(cil[i]);
					RXcheck1 = 0;
					i++;
				}
			}
			
			cil[3] = (cil[0]-48) * 100 + (cil[1] -48) * 10 + (cil[2]-48);
			lcd_gotoxy(0,0);
			lcd_write_int(cil[3],3);
			if(cil[3] >= 0 && cil[3] < 360)
				check = 0;
		}
		
		lcd_gotoxy(0,0);
		lcd_puts("    Keep course     ");
		lcd_gotoxy(0,1);
		lcd_puts("    target: XXX     ");	// azim(12,1)
		lcd_gotoxy(0,2);
		lcd_puts("    actual: XXX     ");	// azim(12,2)
		lcd_gotoxy(0,3);
		lcd_puts("                    ");   
		
		lcd_gotoxy(12,1);
		lcd_putc(cil[0]);
		lcd_putc(cil[1]);
		lcd_putc(cil[2]);
		
		sei();
		
		while(1)
		{
			angle = compas_measure() / 10;
			lcd_gotoxy(12,2);
			lcd_write_int(angle,3);	
			diference = abs(cil[3]-angle);
			stripping = 0;
			
			if( (diference < 10 && diference >= 0 ) || (diference + 359 < 10 && diference +359 >= 0) || (diference - 359 < 10 && diference - 359 >= 0))
			{
				course = COURSE_FRONT;
				stripping = 0;
				diference = cil[3] - angle;
				if (diference < 0)
					stripping = 1;
				if (diference > 0)
					stripping = 3;
				
			}
			else
			{
				
				if(cil[3] >= 0 && cil[3] < 90)		// kdy je cil v 1. kvadrantu ...
				{
					if(angle >= 90 && angle < 180)	// a auto je otoeno do 2. kvadrantu
						course = COURSE_LEFT;
					if(angle > 270 && angle < 360)	// do 4. kvadrantu
						course = COURSE_RIGHT;
					if(angle >= 180 && angle < 270)	// do 3. kvadrantu
					{
						if( (angle-cil[3]) < 180)
							course = COURSE_LEFT;
						else
							course = COURSE_RIGHT;		
					}
					if(angle >= 0 && angle < 90)	//auto je natoeno v 1. kvadrantu
					{
						if(angle < cil[3])
							course = COURSE_RIGHT;
						else
							course = COURSE_LEFT;
					}
				}
				if(cil[3] >= 90 && cil[3] < 180)	// obdoba pro 2. kvadrant
				{
					if(angle >= 0 && angle < 90)
						course = COURSE_RIGHT;
					if(angle >= 270 && angle < 360)
						course = COURSE_LEFT;
					if(angle >= 180 && angle < 270)
					{
						if( (angle-cil[3]) < 180)
							course = COURSE_LEFT;
						else
							course = COURSE_RIGHT;
					}
					if(angle >= 90 && angle < 180)
					{
						if(angle < cil[3])
							course = COURSE_RIGHT;
						else
							course = COURSE_LEFT;
					}
				}
				if(cil[3] >= 180 && cil[3] < 270)	// obdoba pro 3. kvadrant
				{
					if(angle >= 90 && angle < 180)
						course = COURSE_RIGHT;
					if(angle >= 270 && angle < 360)
						course = COURSE_LEFT;
					if(angle >= 0 && angle < 90)
					{
						if( (cil[3] - angle) < 180)
							course = COURSE_RIGHT;
						else
							course = COURSE_LEFT;
					}
					else
					{
						if(angle > cil[3])
							course = COURSE_LEFT;
						else
							course = COURSE_RIGHT;	
					}					
				}
				if(cil[3] >= 270 && cil[3] < 360)	// obdoba pro 4. kvadrant
				{
					if(angle >= 0 && angle < 90)
						course = COURSE_LEFT;
					if(angle >= 180 && angle < 270)
						course = COURSE_RIGHT;
					if(angle >= 90 && angle < 180)
					{
						if( (cil[3] - angle) < 180 )
							course = COURSE_RIGHT;
						else
							course = COURSE_LEFT;
					}
					if(angle >= 270 && angle < 360)
					{
						if(angle > cil[3])
							course = COURSE_LEFT;
						else
							course = COURSE_RIGHT;
					}
				}
			}
			
			d_left = distance_measure_left();
			d_center = distance_measure_center();
			d_right = distance_measure_right();
			
			if(d_center < 15)
				course = COURSE_HOLD;
			
			if(course == COURSE_FRONT)
				gearbox = 'B';
			else
				gearbox = 'D';		
			engines(course);

			distance_print(d_left,d_center,d_right);
			serial_1_data_to_pc(d_left,d_center,d_right,angle*10,course,gearbox,stripping);
		}
	}
	
	if(RXreturn1 == '4' || key == '4') // MODE 4 (GPS mode
	{
		int i;
		int j;
		int k;
		BYTE time[6];
		BYTE latitude[15];
		BYTE longtitude[15];
		BYTE altitude[10];
		BYTE satelits[4];
		
		BYTE data_gps;
		BYTE time_hour;
		BYTE time_min;
		BYTE time_sec;
		BYTE satelity;
		BYTE vyska;
		
		lcd_gotoxy(0,0);					// poaten inicializace displaye
		lcd_puts("  Robot DELUXE 2.0  ");
		lcd_gotoxy(0,1);
		lcd_puts("                    "); // smer (5,1) , rych (12,1), kla(18,1)
		lcd_gotoxy(0,2);
		lcd_puts("                    "); // COM (7,2) azimut(16,2)
		lcd_gotoxy(0,3);
		lcd_puts("                    ");
		
		lcd_gotoxy(0,0);
		lcd_puts("format: X");
		lcd_gotoxy(0,1);
		lcd_puts("data :  X");
		
		sei();
		_delay_ms(500);
		while(1)
		{
			received0 = serial_0_read();
			serial_1_write(received0);
			if(received0 == '$')
			{
				received0 = serial_0_read();
				serial_1_write(received0);
				if(received0 == 'G')
				{
					received0 = serial_0_read();
					serial_1_write(received0);
					if(received0 == 'P')
					{
						received0 = serial_0_read();
						serial_1_write(received0);
						if(received0 == 'G')
						{
							received0 = serial_0_read();
							serial_1_write(received0);
							if(received0 == 'G')
							{
								received0 = serial_0_read();
								serial_1_write(received0);
								if(received0 == 'A')
								{
									serial_1_write(serial_0_read());	// ','   
									
									for(i = 0 ; i < 6 ; i++)			// cteni casu ... cas je vzdy
										time[i] = serial_0_read();

									serial_0_read();		// vznecha .000
									serial_0_read();
									serial_0_read();
									serial_0_read();
									
									// CTENI JEDNOTLIVYCH UDAJU V RETEZCU //

									for (i = 2, k = 0; i < 4; j++)
									{
										received0 = serial_0_read();
									    if (i == 2 || i == 3)               // latitude
									        latitude[k++] = received0;
									    if (received0 == ',')
									        i++; 
									}
										
									for (k = 0; i < 6; j++)
									{
										received0 = serial_0_read();
									    if (i == 4 || i == 5)               // longtitude
									        longtitude[k++] =received0; 
									    if (received0 == ',')
									        i++; 
									}

									for (k = 0; i < 8; j++)
									{
										received0 = serial_0_read();
									    if (i ==7)                          // number of satelits
									        satelits[k++] = received0;
									    if (received0 == ',')
									        i++;
									}

									for (k = 0; i < 10; j++)
									{
										received0 = serial_0_read();
									    if (i == 9)                          // number of satelits
									        altitude[k++] = received0;
									    if (received0 == ',')
									        i++;
									}  	
										
									time_hour = (time[0]-48) * 10;
									time_hour += (time[1]-48);
									time_min = (time[2]-48) * 10;
									time_min += (time[3]-48);
									time_sec = (time[4]-48) * 10;
									time_sec += (time[5]-48);
									
									
									if( (latitude[1]) >= '0' && (latitude[1]) <= '9') // overi, esi chodi data
										data_gps = 1;
									else
										data_gps = 0;
										
									lcd_gotoxy(8,1);
									lcd_putc(data_gps+48);
									
									lcd_gotoxy(0,2);
										for(i = 0 ; i < 4 ; i++)
											lcd_putc(altitude[i]);
									
									// TIME //	
									lcd_gotoxy(12,0);
									lcd_write_int(time_hour,2);
									lcd_putc(':');
									lcd_write_int(time_min,2);
									lcd_putc(':');
									lcd_write_int(time_sec,2);
									
									// SATELITS //
									if(satelits[1] == ',')
										satelity = satelits[0]-48;
									else
										satelity = (satelits[0]-48)*10 + (satelits[0]-48);		
									lcd_gotoxy(12,1);
									lcd_puts("sat : ");
									lcd_gotoxy(18,1);
									lcd_write_int(satelity,2);	
									
									lcd_gotoxy(8,0);
									lcd_putc(latitude[1]);
									
									if(data_gps == 1)
									{
										// ALTITUDE //
										vyska = 0;
										for(i = 0 ; altitude[i] != '.' ; i++)
										{
											vyska *= 10;
											vyska += (altitude[i]-48);
										}
											
										lcd_gotoxy(12,2);
										lcd_puts("alt :");
										lcd_gotoxy(16,2);
										lcd_write_int(vyska,4);	
										lcd_gotoxy(0,2);
										
										lcd_gotoxy(0,3);	
										for (i = 0 ; i < 9 ; i++)
											lcd_putc(latitude[i]);
											lcd_gotoxy(10,3);	
										for (i = 0 ; i < 10 ; i++)
											lcd_putc(longtitude[i]);
									}										
								}   
							}   
						}
					}
				}   
			}			
		}
		
	}
}