﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Robot_Controllrer_v3._0
{
    public partial class Autonome_mode : Form
    {
        Form menu;
        public Autonome_mode(string port, string baudrate, Form menu_s)
        {
            InitializeComponent();
            cb_ports.Items.Add(port);
            cb_ports.Text = port;
            cb_baudrate.Text = baudrate;
            menu = menu_s;
        }

        private void OnLoad(object sender, EventArgs e)
        {
            try
            {
                // nacte poyadovany port
                serialPort1.PortName = cb_ports.Text;
                // nacte baudrate podru
                serialPort1.BaudRate = Convert.ToInt32(cb_baudrate.Text);

                serialPort1.Open();

                if (serialPort1.IsOpen)
                {
                    cb_ports.Enabled = false;
                    cb_baudrate.Enabled = false;

                    byte[] znak = new byte[1];
                    znak[0] = 2+48;
                    serialPort1.Write(znak, 0, 1);
                }
                
            }
            catch (Exception)
            {
                status.Text = "Při otevření portu došlo k chybě";
            }

            try
            {
                pb_you.Image = new Bitmap("you.bmp");
                pb_compass.Image = new Bitmap("rose.bmp");
                pb_left.Image = new Bitmap("krizek");
                pb_right.Image = new Bitmap("krizek");
                pb_center.Image = new Bitmap("krizek");
            }
            catch (Exception)
            {
                status.Text = "nejsou k dispozici obrazky";
            }

        }

        private void OnDataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {
            byte[] data = new byte[15];
            byte[] temp = new byte[3];
            int left;
            int center;
            int right;
            int gearbox;
            int course;
            int azimuth;

            try
            {
                serialPort1.Read(data, 0, 15);
            }
            catch (Exception) { }


            // kontrolni v=zpis do label4
            string str = System.Text.ASCIIEncoding.ASCII.GetString(data);
            if (label4.InvokeRequired)
            {
                label4.Invoke(new MethodInvoker(delegate { label4.Text = str; }));
            }

            course = data[0];
            gearbox = data[1];
            left = (data[2] - 48) * 100 + (data[3] - 48) * 10 + (data[4] - 48);
            center = (data[5] - 48) * 100 + (data[6] - 48) * 10 + (data[7] - 48);
            right = (data[8] - 48) * 100 + (data[9] - 48) * 10 + (data[10] - 48);
            azimuth = (data[11] - 48) * 100 + (data[12] - 48) * 10 + (data[13] - 48);

            // PICTURES //
            try
            {
                if (left >= 25)
                    pb_left.Image = new Bitmap("fajfka.bmp");
                else
                    pb_left.Image = new Bitmap("krizek.bmp");

                if (center >= 25)
                    pb_center.Image = new Bitmap("fajfka.bmp");
                else
                    pb_center.Image = new Bitmap("krizek.bmp");

                if (right >= 25)
                    pb_right.Image = new Bitmap("fajfka.bmp");
                else
                    pb_right.Image = new Bitmap("krizek.bmp");
            }
            catch (Exception)
            {
                status.Text = "Nejsou k dispozici obrázky";
            }
            // COURSE // 

            if (course == '8')
                tb_course.Invoke(new MethodInvoker(delegate { tb_course.Text = "FORWARD"; }));
            if (course == '4')
                tb_course.Invoke(new MethodInvoker(delegate { tb_course.Text = "LEFT"; }));
            if (course == '5')
                tb_course.Invoke(new MethodInvoker(delegate { tb_course.Text = "STOP"; }));
            if (course == '6')
                tb_course.Invoke(new MethodInvoker(delegate { tb_course.Text = "RIGHT"; }));
            if (course == '2')
                tb_course.Invoke(new MethodInvoker(delegate { tb_course.Text = "BACK"; }));


            // GEARBOX //


            if (gearbox == 65)  // 'A'
                tb_speed.Invoke(new MethodInvoker(delegate { tb_speed.Text = "ULTRA"; }));
            if (gearbox == 66)  // 'B'
                tb_speed.Invoke(new MethodInvoker(delegate { tb_speed.Text = "HIGH"; }));
            if (gearbox == 67)  // 'C'
                tb_speed.Invoke(new MethodInvoker(delegate { tb_speed.Text = "MODERATE"; }));
            if (gearbox == 68)  // 'D'
                tb_speed.Invoke(new MethodInvoker(delegate { tb_speed.Text = "SLOW"; }));


            // LEFT //

            for (int i = 0; i < 3; i++)
            {
                temp[i] = data[i + 2];
            }

            str = System.Text.ASCIIEncoding.ASCII.GetString(temp);
            tb_left.Invoke(new MethodInvoker(delegate { tb_left.Text = str; }));

            // CENTER //

            for (int i = 0; i < 3; i++)
            {
                temp[i] = data[i + 5];
            }

            str = System.Text.ASCIIEncoding.ASCII.GetString(temp);
            tb_center.Invoke(new MethodInvoker(delegate { tb_center.Text = str; }));

            // RIGHT //

            for (int i = 0; i < 3; i++)
            {
                temp[i] = data[i + 8];
            }

            str = System.Text.ASCIIEncoding.ASCII.GetString(temp);
            tb_right.Invoke(new MethodInvoker(delegate { tb_right.Text = str; }));

            // DRAW AZIMUTH //

            float angle = azimuth * (float)Math.PI / 180;
            float xangle = (float)Math.Sin(angle)*50;
            float yangle = (float)Math.Cos(angle)*50;
            Bitmap compass = new Bitmap("compass.bmp");
            Graphics g = Graphics.FromImage(compass);
            System.Drawing.Pen myPen = new Pen(System.Drawing.Color.Black);
            myPen.Width = 7;
            g.DrawLine(myPen, 75, 75, -xangle + 75, yangle + 75);
            myPen.Color = Color.Red;
            g.DrawLine(myPen, 75, 75, xangle + 75, -yangle + 75);
            pb_compass.Image = compass;

            tb_azimuth.Invoke(new MethodInvoker(delegate { tb_azimuth.Text = Convert.ToString(azimuth); }));
        }

        private void OnClosed(object sender, FormClosedEventArgs e)
        {
            byte[] znak = new byte[1]; // reset robot
            znak[0] = 0;
            serialPort1.Write(znak, 0, 1);
            
            serialPort1.Close();
            menu.Close();
        }
    }
}
