﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Robot_Controllrer_v3._0
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (radioButton1.Checked == true || radioButton2.Checked == true || radioButton3.Checked == true)
            {
                try
                {
                    // send mode //

                    serialPort1.PortName = cb_ports.Text;
                    serialPort1.BaudRate = Convert.ToInt32(cb_baudrate.Text);

                    serialPort1.Open(); // test, zda-li zařízení je dostupno

                    if (serialPort1.IsOpen)
                    {
                        serialPort1.Close();
                        if (radioButton1.Checked == true)
                        {
                            Manual_mode mode = new Manual_mode(cb_ports.Text, cb_baudrate.Text, this);
                            mode.Show();
                        }
                        if (radioButton2.Checked == true)
                        {
                            Autonome_mode mode = new Autonome_mode(cb_ports.Text, cb_baudrate.Text, this);
                            mode.Show();
                        }
                        if (radioButton3.Checked == true)
                        {
                            Azimuth_mode mode = new Azimuth_mode(cb_ports.Text, cb_baudrate.Text, this);
                            mode.Show();
                        }
                    }
                    this.Visible = false;
                }
                catch (Exception)
                {
                    status.Text = "Při otevření portu došlo k chybě";
                    MessageBox.Show("Nepodařilo se navázat spojení.");
                }
            }
        }

        private void OnLoad(object sender, EventArgs e)
        {
            string[] ports;

            try
            {
                ports = System.IO.Ports.SerialPort.GetPortNames();
                cb_ports.Items.Clear();
                foreach (string port in ports)
                {
                    cb_ports.Items.Add(port);
                }
            }
            catch (Exception)
            {
                status.Text = "COM nebyl nalezen";
            }
        }
    }
}
