﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Robot_Controllrer_v3._0
{
    public partial class Manual_mode : Form
    {
        Form menu;
        Bitmap bm = new Bitmap(320, 200); // dvojnasobne royliseni 176*144
        byte[] received = new byte[320 * 200+1]; // 1 byte na urcyzni obrozka
        int counter = 0;
        int check = 0;

        public Manual_mode(string port, string baudrate, Form menu_s)
        {
            InitializeComponent();
            cb_ports.Items.Add(port);
            cb_ports.Text = port;
            cb_baudrate.Text = baudrate;
            menu = menu_s;
        }

        private void OnLoad(object sender, EventArgs e)
        {
            try
            {
                // nacte poyadovany port
                serialPort1.PortName = cb_ports.Text;
                // nacte baudrate podru
                serialPort1.BaudRate = Convert.ToInt32(cb_baudrate.Text);

                serialPort1.Open();

                if (serialPort1.IsOpen)
                {
                    cb_ports.Enabled = false;
                    cb_baudrate.Enabled = false;

                    byte[] znak = new byte[1];
                    znak[0] = 1+48;
                    serialPort1.Write(znak, 0, 1);
                }

                for (int j = 0; j < 200; j++)
                {
                    for (int i = 0; i < 320; i++)
                    {
                        if (j == 0 || j == 199)
                            bm.SetPixel(i, j, Color.Black);
                        if (i == 0 || i == 319)
                            bm.SetPixel(i, j, Color.Black);
                    }
                }
                pictureBox1.Image = bm;
            }
            catch (Exception)
            {
                status.Text = "Při otevření portu došlo k chybě";
            }

            try
            {
                pb_you.Image = new Bitmap("you.bmp");
            }
            catch (Exception)
            {
                status.Text = "nejsou k dispozici obrazky";
            }
        }

        private void bt_rq_Click(object sender, EventArgs e)
        {
            byte[] znak = new byte[1];
            znak[0] = 0xFF;
            serialPort1.Write(znak, 0, 1);
        }

        private void bt_front_Click(object sender, EventArgs e)
        {
            try
            {
                char[] znak = new char[1];
                znak[0] = '8';
                serialPort1.Write(znak, 0, 1);
            }
            catch (Exception)
            {
                status.Text = "Někde je chyba";
            }
        }

        private void bt_left_Click(object sender, EventArgs e)
        {
            try
            {
                char[] znak = new char[1];
                znak[0] = '4';
                serialPort1.Write(znak, 0, 1);
            }
            catch (Exception)
            {
                status.Text = "Někde je chyba";
            }
        }

        private void bt_stop_Click(object sender, EventArgs e)
        {
            try
            {
                char[] znak = new char[1];
                znak[0] = '5';
                serialPort1.Write(znak, 0, 1);
            }
            catch (Exception)
            {
                status.Text = "Někde je chyba";
            }
        }

        private void bt_right_Click(object sender, EventArgs e)
        {
            try
            {
                char[] znak = new char[1];
                znak[0] = '6';
                serialPort1.Write(znak, 0, 1);
            }
            catch (Exception)
            {
                status.Text = "Někde je chyba";
            }
        }

        private void bt_back_Click(object sender, EventArgs e)
        {
            try
            {
                char[] znak = new char[1];
                znak[0] = '2';
                serialPort1.Write(znak, 0, 1);
            }
            catch (Exception)
            {
                status.Text = "Někde je chyba";
            }
        }

        private void bt_ultra_Click(object sender, EventArgs e)
        {
            try
            {
                char[] znak = new char[1];
                znak[0] = 'A';
                serialPort1.Write(znak, 0, 1);
            }
            catch (Exception)
            {
                status.Text = "Někde je chyba";
            }
        }

        private void bt_high_Click(object sender, EventArgs e)
        {
            try
            {
                char[] znak = new char[1];
                znak[0] = 'B';
                serialPort1.Write(znak, 0, 1);
            }
            catch (Exception)
            {
                status.Text = "Někde je chyba";
            }
        }

        private void bt_moderate_Click(object sender, EventArgs e)
        {
            try
            {
                char[] znak = new char[1];
                znak[0] = 'C';
                serialPort1.Write(znak, 0, 1);
            }
            catch (Exception)
            {
                status.Text = "Někde je chyba";
            }
        }

        private void bt_slow_Click(object sender, EventArgs e)
        {
            try
            {
                char[] znak = new char[1];
                znak[0] = 'D';
                serialPort1.Write(znak, 0, 1);
            }
            catch (Exception)
            {
                status.Text = "Někde je chyba";
            }
        }

        private void bt_easyleft_Click(object sender, EventArgs e)
        {
            try
            {
                char[] znak = new char[1];
                znak[0] = '1';
                serialPort1.Write(znak, 0, 1);
            }
            catch (Exception)
            {
                status.Text = "Někde je chyba";
            }
        }

        private void bt_balanced_Click(object sender, EventArgs e)
        {
            try
            {
                char[] znak = new char[1];
                znak[0] = '0';
                serialPort1.Write(znak, 0, 1);
            }
            catch (Exception)
            {
                status.Text = "Někde je chyba";
            }
        }

        private void bt_easyright_Click(object sender, EventArgs e)
        {
            try
            {
                char[] znak = new char[1];
                znak[0] = '3';
                serialPort1.Write(znak, 0, 1);
            }
            catch (Exception)
            {
                status.Text = "Někde je chyba";
            }
        }

        private void OnKeyUp(object sender, KeyEventArgs e)
        {
            char[] povel = new char[1];
            povel[0] = '5';
            serialPort1.Write(povel, 0, 1);
        }

        private void OnKeyDown(object sender, KeyEventArgs e)
        {
            char[] povel = new char[1];


            if (e.KeyCode == Keys.W || e.KeyCode == Keys.Up)
            {
                povel[0] = '8';
                serialPort1.Write(povel, 0, 1);
            }
            if (e.KeyCode == Keys.S || e.KeyCode == Keys.Down)
            {
                povel[0] = '2';
                serialPort1.Write(povel, 0, 1);
            }
            if (e.KeyCode == Keys.A || e.KeyCode == Keys.Left)
            {
                povel[0] = '4';
                serialPort1.Write(povel, 0, 1);
            }
            if (e.KeyCode == Keys.D || e.KeyCode == Keys.Right)
            {
                povel[0] = '6';
                serialPort1.Write(povel, 0, 1);
            }
            // balancovaní rychlosti pásů
            if (e.KeyCode == Keys.Z || e.KeyCode == Keys.Y)
            {
                povel[0] = '1';
                serialPort1.Write(povel, 0, 1);
            }
            if (e.KeyCode == Keys.X)
            {
                povel[0] = '0';
                serialPort1.Write(povel, 0, 1);
            }
            if (e.KeyCode == Keys.C)
            {
                povel[0] = '3';
                serialPort1.Write(povel, 0, 1);
            }

            // rychlosti
            if (e.KeyCode == Keys.D1)
            {
                povel[0] = 'A';
                serialPort1.Write(povel, 0, 1);
            }
            if (e.KeyCode == Keys.D2)
            {
                povel[0] = 'B';
                serialPort1.Write(povel, 0, 1);
            }
            if (e.KeyCode == Keys.D3)
            {
                povel[0] = 'C';
                serialPort1.Write(povel, 0, 1);
            }
            if (e.KeyCode == Keys.D4)
            {
                povel[0] = 'D';
                serialPort1.Write(povel, 0, 1);
            }
        }

        private void OnDataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {
            byte[] data = new byte[15];
            byte[] temp = new byte[3];
            int left;
            int center;
            int right;
            int gearbox;
            int course;
            int azimuth;
            int balanced;

            if(check == 0)
            {
                try
                {
                    serialPort1.Read(data, 0, 15);
                }
                catch (Exception) { }

                if (data[0] == 127)
                {
                    check = 1;             
                }

                if (check == 0)
                {
                    // kontrolni v=zpis do label4
                    string str = System.Text.ASCIIEncoding.ASCII.GetString(data);
                    if (label5.InvokeRequired)
                    {
                        label5.Invoke(new MethodInvoker(delegate { label5.Text = str; }));
                    }

                    course = data[0];
                    gearbox = data[1];
                    left = (data[2] - 48) * 100 + (data[3] - 48) * 10 + (data[4] - 48);
                    center = (data[5] - 48) * 100 + (data[6] - 48) * 10 + (data[7] - 48);
                    right = (data[8] - 48) * 100 + (data[9] - 48) * 10 + (data[10] - 48);
                    azimuth = (data[11] - 48) * 100 + (data[12] - 48) * 10 + (data[13] - 48);
                    balanced = data[14] - 48;

                    // PICTURES //
                    try
                    {
                        if (left >= 30)
                            pb_left.Image = new Bitmap("fajfka.bmp");
                        else
                            pb_left.Image = new Bitmap("krizek.bmp");

                        if (center >= 30)
                            pb_center.Image = new Bitmap("fajfka.bmp");
                        else
                            pb_center.Image = new Bitmap("krizek.bmp");

                        if (right >= 30)
                            pb_right.Image = new Bitmap("fajfka.bmp");
                        else
                            pb_right.Image = new Bitmap("krizek.bmp");
                    }
                    catch (Exception)
                    {
                        status.Text = "Nejsou k dispozici obrázky";
                    }
                    // COURSE // 

                    if (course == '8')
                        tb_course.Invoke(new MethodInvoker(delegate { tb_course.Text = "FORWARD"; }));
                    if (course == '4')
                        tb_course.Invoke(new MethodInvoker(delegate { tb_course.Text = "LEFT"; }));
                    if (course == '5')
                        tb_course.Invoke(new MethodInvoker(delegate { tb_course.Text = "STOP"; }));
                    if (course == '6')
                        tb_course.Invoke(new MethodInvoker(delegate { tb_course.Text = "RIGHT"; }));
                    if (course == '2')
                        tb_course.Invoke(new MethodInvoker(delegate { tb_course.Text = "BACK"; }));


                    // GEARBOX //


                    if (gearbox == 65)  // 'A'
                        tb_speed.Invoke(new MethodInvoker(delegate { tb_speed.Text = "ULTRA"; }));
                    if (gearbox == 66)  // 'B'
                        tb_speed.Invoke(new MethodInvoker(delegate { tb_speed.Text = "HIGH"; }));
                    if (gearbox == 67)  // 'C'
                        tb_speed.Invoke(new MethodInvoker(delegate { tb_speed.Text = "MODERATE"; }));
                    if (gearbox == 68)  // 'D'
                        tb_speed.Invoke(new MethodInvoker(delegate { tb_speed.Text = "SLOW"; }));


                    // LEFT //

                    for (int i = 0; i < 3; i++)
                    {
                        temp[i] = data[i + 2];
                    }

                    str = System.Text.ASCIIEncoding.ASCII.GetString(temp);
                    tb_left.Invoke(new MethodInvoker(delegate { tb_left.Text = str; }));

                    // CENTER //

                    for (int i = 0; i < 3; i++)
                    {
                        temp[i] = data[i + 5];
                    }

                    str = System.Text.ASCIIEncoding.ASCII.GetString(temp);
                    tb_center.Invoke(new MethodInvoker(delegate { tb_center.Text = str; }));

                    // RIGHT //

                    for (int i = 0; i < 3; i++)
                    {
                        temp[i] = data[i + 8];
                    }

                    str = System.Text.ASCIIEncoding.ASCII.GetString(temp);
                    tb_right.Invoke(new MethodInvoker(delegate { tb_right.Text = str; }));

                    // DRAW AZIMUTH //

                    float angle = azimuth * (float)Math.PI / 180;
                    float xangle = (float)Math.Sin(angle) * 50;
                    float yangle = (float)Math.Cos(angle) * 50;
                    Bitmap compass = new Bitmap("compass.bmp");
                    Graphics g = Graphics.FromImage(compass);
                    System.Drawing.Pen myPen = new Pen(System.Drawing.Color.Black);
                    myPen.Width = 7;
                    g.DrawLine(myPen, 75, 75, -xangle + 75, yangle + 75);
                    myPen.Color = Color.Red;
                    g.DrawLine(myPen, 75, 75, xangle + 75, -yangle + 75);
                    pb_compass.Image = compass;

                    tb_azimuth.Invoke(new MethodInvoker(delegate { tb_azimuth.Text = Convert.ToString(azimuth); }));

                    // BALANCED //
                    if (balanced == 1)
                        tb_balanced.Invoke(new MethodInvoker(delegate { tb_balanced.Text = "easy left"; }));
                    if (balanced == 0)
                        tb_balanced.Invoke(new MethodInvoker(delegate { tb_balanced.Text = "balanced"; }));
                    if (balanced == 3)
                        tb_balanced.Invoke(new MethodInvoker(delegate { tb_balanced.Text = "easy right"; }));
                }
            }
            if (check == 1)
            { 
                string str = serialPort1.ReadExisting();
                int color;
                foreach (byte s in str)
                {
                    received[counter++] = s;

                    if (counter % 1000 == 0) { progressBar1.Invoke(new MethodInvoker(delegate { progressBar1.Value++; })); }
                    if (counter == 320 * 200+1) break;
                }

                if (counter == (320 * 200)+1)
                {
                    counter = 0;
                    for (int j = 0; j < 200; j++)
                    {
                        for (int i = 0; i < 320; i++)
                        {
                            color = received[j * 320 + i];
                            if (color == 1)
                            {
                                bm.SetPixel(i , j, Color.Red);
                            }

                            if (color == 2)
                            {
                                bm.SetPixel(i   , j   , Color.Orange);
                            }

                            if (color == 3)
                            {
                                bm.SetPixel(i   , j   , Color.Green);
                            }

                            if (color == 4)
                            {
                                bm.SetPixel(i   , j   , Color.Blue);
                            }

                            if (color == 5)
                            {
                                bm.SetPixel(i   , j   , Color.Aqua);
                            }

                            if (color == 6)
                            {
                                bm.SetPixel(i   , j   , Color.Yellow);
                            }

                            if (color == 7)
                            {
                                bm.SetPixel(i   , j   , Color.Pink);
                            }

                            if (color == 8)
                            {
                                bm.SetPixel(i   , j   , Color.Brown);
                            }

                            if (color > 8 || color == 0)
                            {
                                bm.SetPixel(i   , j   , Color.FromArgb(color * 4, color * 4, color * 4));
                            }
                        }
                    }
                    counter = 0;
                    pictureBox1.Image = bm;

                    if (received[64000] == 0)
                        label19.Invoke(new MethodInvoker(delegate { label19.Text = "Trojuhelnik"; }));
                    if (received[64000] == 1)
                        label19.Invoke(new MethodInvoker(delegate { label19.Text = "Gyzch"; }));
                    if (received[64000] == 2)
                        label19.Invoke(new MethodInvoker(delegate { label19.Text = "vLEVO"; }));
                    if (received[64000] == 3)
                        label19.Invoke(new MethodInvoker(delegate { label19.Text = "vPRAVO"; }));
                    if (received[64000] == 126)
                        label19.Invoke(new MethodInvoker(delegate { label19.Text = "NIC"; }));

                    progressBar1.Invoke(new MethodInvoker(delegate { progressBar1.Value = 0; }));
                    check = 0;
                }
            }
        }

        private void OnClosed(object sender, FormClosedEventArgs e)
        {
            byte[] znak = new byte[1]; // reset robot
            znak[0] = 0;
            serialPort1.Write(znak, 0, 1);

            serialPort1.Close();
            menu.Close();
        }
    }
}
