#include "stm32f4xx.h"
#include <stdio.h>
 void LEDinit(void)
{
  RCC->AHB1ENR  |= ((1UL <<  1) );         /* Enable GPIOB clock                */

  GPIOB->MODER    |= (  (1UL << 2*10) |
                       (1UL << 2*13) |
                       (1UL << 2*14) |
                       (1UL << 2*15)  );   /* PD.12..15 is output               */
 
  GPIOB->OTYPER   |= ( (0UL <<   10) |
                       (1UL <<   13) |
                       (1UL <<   14) |
                       (1UL <<   15)  );   /* PD.12..15 is output Push-Pull     */
   /* PD.12..15 is 50MHz Fast Speed     */
  GPIOB->OSPEEDR  |=  ((0UL << 2*10) |
                       (0UL << 2*13) | 
                       (0UL << 2*14) | 
                       (0UL << 2*15)  ); 
    /* PD.12 is Pull up              */
  GPIOB->PUPDR    |=  ( (1UL << 2*10)| 
                       (1UL << 2*12) ); 

GPIOB->ODR |= ((1 << 10)| (1 << 13)|(1 << 14)|(1 << 15) );
}

void USART_Inicializace(void)
{
	GPIO_InitTypeDef GPIO_Tx;
   	GPIO_InitTypeDef GPIO_Rx;
	USART_InitTypeDef USART_InitStructure;
 NVIC_InitTypeDef NVIC_InitStructure;

  RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART2, ENABLE);		  // 1.
	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOD,ENABLE); 	// 2.
	GPIO_PinAFConfig  ( GPIOD, GPIO_PinSource5 , GPIO_AF_USART2) ;
	GPIO_PinAFConfig  ( GPIOD, GPIO_PinSource6 , GPIO_AF_USART2) ;
GPIO_Tx.GPIO_OType = GPIO_OType_PP;
GPIO_Tx.GPIO_PuPd = GPIO_PuPd_UP;
GPIO_Tx.GPIO_Mode = GPIO_Mode_AF;
GPIO_Tx.GPIO_Pin = GPIO_Pin_5;
GPIO_Tx.GPIO_Speed = GPIO_Speed_50MHz;
GPIO_Init(GPIOD, &GPIO_Tx);

GPIO_Rx.GPIO_Mode = GPIO_Mode_AF;
GPIO_Rx.GPIO_Pin = GPIO_Pin_6;
GPIO_Init(GPIOD, &GPIO_Rx);


  	USART_InitStructure.USART_BaudRate = 57600;
  	USART_InitStructure.USART_WordLength = USART_WordLength_8b;
  	USART_InitStructure.USART_StopBits = USART_StopBits_1;
  	USART_InitStructure.USART_Parity = USART_Parity_No;
  	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
  	USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
	USART_Init(USART2, &USART_InitStructure);

	USART_Cmd(USART2, ENABLE);

	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_1);
  	NVIC_InitStructure.NVIC_IRQChannel = USART2_IRQn;
  	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
  	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  	NVIC_Init(&NVIC_InitStructure);
	 	USART_ITConfig(USART2, USART_IT_RXNE, ENABLE);
/*
	syntax:
	USART_SendData(USART2,'x' );
	 while(USART_GetFlagStatus(USART2, USART_FLAG_TXE) == RESET);
    USART_ReceiveData(USART2);
	*/

}									 


void INT_Init(void)
{
 EXTI_InitTypeDef   EXTI_InitStructure;
  GPIO_InitTypeDef   GPIO_InitStructure;
  NVIC_InitTypeDef   NVIC_InitStructure;

  /* Enable GPIOA clock */
  RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOB, ENABLE);
  /* Enable SYSCFG clock */
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_SYSCFG, ENABLE);
  
 
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12;
  GPIO_Init(GPIOB, &GPIO_InitStructure);

  /* Connect EXTI Line0 to PA0 pin */
  SYSCFG_EXTILineConfig(EXTI_PortSourceGPIOB, EXTI_PinSource12);

  /* Configure EXTI Line0 */
  EXTI_InitStructure.EXTI_Line = EXTI_Line12;
  EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;
  EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Rising;  
  EXTI_InitStructure.EXTI_LineCmd = ENABLE;
  EXTI_Init(&EXTI_InitStructure);

  /* Enable and set EXTI Line0 Interrupt to the lowest priority */
  NVIC_InitStructure.NVIC_IRQChannel = EXTI15_10_IRQn;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0x0F;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0x0F;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);
}

 void CAMio(void)
{
  RCC->AHB1ENR  |= ((1UL <<  4) );         /* Enable GPIOD clock                */

  GPIOE->MODER    |= (
                       (1UL << 2*11) |
                       (1UL << 2*12)   );   /* PD.12..15 is output               */
 
  GPIOE->OSPEEDR  |=  (
                       (2UL << 2*11) | 
                       (2UL << 2*12)  ); 
    /* PD.12..15 is Pull up              */
//  GPIOB->PUPDR    |=  (
//                       (1UL << 2*13) | 
//                       (1UL << 2*14) | 
//                       (1UL << 2*15)  ); 
//

}

void USART6_Inicializace(void)
{
	GPIO_InitTypeDef GPIO_Tx;
	GPIO_InitTypeDef GPIO_RTS;

   	GPIO_InitTypeDef GPIO_Rx;
	GPIO_InitTypeDef GPIO_CTS;
   	
	USART_InitTypeDef USART_InitStructure;
 NVIC_InitTypeDef NVIC_InitStructure;

  RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART6, ENABLE);		  // 1.
	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOG,ENABLE); 	// 2.

	GPIO_PinAFConfig  ( GPIOG, GPIO_PinSource14 , GPIO_AF_USART6) ;	 //TX
	GPIO_PinAFConfig  ( GPIOG, GPIO_PinSource12 , GPIO_AF_USART6) ;	 // RTS

	GPIO_PinAFConfig  ( GPIOG, GPIO_PinSource9 , GPIO_AF_USART6) ;	 //Rx
	GPIO_PinAFConfig  ( GPIOG, GPIO_PinSource13 , GPIO_AF_USART6) ;	  //CTS

GPIO_Tx.GPIO_OType = GPIO_OType_PP;
GPIO_Tx.GPIO_PuPd = GPIO_PuPd_UP;
GPIO_Tx.GPIO_Mode = GPIO_Mode_AF;			  //Tx
GPIO_Tx.GPIO_Pin = GPIO_Pin_14;
GPIO_Tx.GPIO_Speed = GPIO_Speed_50MHz;
GPIO_Init(GPIOG, &GPIO_Tx);

GPIO_RTS.GPIO_OType = GPIO_OType_PP;
GPIO_RTS.GPIO_PuPd = GPIO_PuPd_UP;
GPIO_RTS.GPIO_Mode = GPIO_Mode_AF;		  //RTS
GPIO_RTS.GPIO_Pin = GPIO_Pin_12;
GPIO_RTS.GPIO_Speed = GPIO_Speed_50MHz;
GPIO_Init(GPIOG, &GPIO_RTS);


GPIO_Rx.GPIO_Mode = GPIO_Mode_AF;
GPIO_Rx.GPIO_Pin = GPIO_Pin_9;		  //RX
GPIO_Init(GPIOG, &GPIO_Rx);

GPIO_CTS.GPIO_Mode = GPIO_Mode_AF;
GPIO_CTS.GPIO_Pin = GPIO_Pin_13;		  //CTS
GPIO_Init(GPIOG, &GPIO_CTS);


  	USART_InitStructure.USART_BaudRate = 115200;
  	USART_InitStructure.USART_WordLength = USART_WordLength_8b;
  	USART_InitStructure.USART_StopBits = USART_StopBits_1;
  	USART_InitStructure.USART_Parity = USART_Parity_No;
  	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
  	USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
	USART_Init(USART6, &USART_InitStructure);

	USART_Cmd(USART6, ENABLE);
//
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_1);
  	NVIC_InitStructure.NVIC_IRQChannel = USART6_IRQn;
  	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
  	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  	NVIC_Init(&NVIC_InitStructure);
	 	USART_ITConfig(USART6, USART_IT_RXNE, ENABLE);

}

void USART1_Inicializace(void)
{
	GPIO_InitTypeDef GPIO_Tx;
	

   	GPIO_InitTypeDef GPIO_Rx;
	
   	
	USART_InitTypeDef USART_InitStructure;
 NVIC_InitTypeDef NVIC_InitStructure;

  RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1, ENABLE);		  // 1.
	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA,ENABLE); 	// 2.

	GPIO_PinAFConfig  ( GPIOA, GPIO_PinSource9 , GPIO_AF_USART1) ;	 //TX
	GPIO_PinAFConfig  ( GPIOA, GPIO_PinSource10 , GPIO_AF_USART1) ;	 //Rx
	

GPIO_Tx.GPIO_OType = GPIO_OType_PP;
GPIO_Tx.GPIO_PuPd = GPIO_PuPd_UP;
GPIO_Tx.GPIO_Mode = GPIO_Mode_AF;			  //Tx
GPIO_Tx.GPIO_Pin = GPIO_Pin_9;
GPIO_Tx.GPIO_Speed = GPIO_Speed_50MHz;
GPIO_Init(GPIOA, &GPIO_Tx);



GPIO_Rx.GPIO_Mode = GPIO_Mode_AF;
GPIO_Rx.GPIO_Pin = GPIO_Pin_10;		  //RX
GPIO_Init(GPIOA, &GPIO_Rx);



  	USART_InitStructure.USART_BaudRate = 57600;
  	USART_InitStructure.USART_WordLength = USART_WordLength_8b;
  	USART_InitStructure.USART_StopBits = USART_StopBits_1;
  	USART_InitStructure.USART_Parity = USART_Parity_No;
  	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
  	USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
	USART_Init(USART1, &USART_InitStructure);

	USART_Cmd(USART1, ENABLE);
//
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_1);
  	NVIC_InitStructure.NVIC_IRQChannel = USART1_IRQn;
  	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
  	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
  	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  	NVIC_Init(&NVIC_InitStructure);
	 	USART_ITConfig(USART1, USART_IT_RXNE, ENABLE);

}

