/**
  ******************************************************************************
  * @file    Project/STM32F4xx_StdPeriph_Template/stm32f4xx_it.c 
  * @author  MCD Application Team
  * @version V1.0.0
  * @date    30-September-2011
  * @brief   Main Interrupt Service Routines.
  *          This file provides template for all exceptions handler and 
  *          peripherals interrupt service routine.
  ******************************************************************************
  * @attention
  *
  * THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
  * WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
  * TIME. AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY
  * DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
  * FROM THE CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
  * CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
  *
  * <h2><center>&copy; COPYRIGHT 2011 STMicroelectronics</center></h2>
  ******************************************************************************
  */ 

/* Includes ------------------------------------------------------------------*/
#include "stm32f4xx_it.h"
#include "main.h"
static int on=1;
 int poslat = 0;
 u8 mereni[15];
  static u8 interni=0,preskoc;
void NMI_Handler(void)
{
}

/**
  * @brief  This function handles Hard Fault exception.
  * @param  None
  * @retval None
  */
void HardFault_Handler(void)
{
  /* Go to infinite loop when Hard Fault exception occurs */
  
   
  while (1)
  {
  
  }
}

/**
  * @brief  This function handles Memory Manage exception.
  * @param  None
  * @retval None
  */
void MemManage_Handler(void)
{
  /* Go to infinite loop when Memory Manage exception occurs */
  while (1)
  {
  }
}

/**
  * @brief  This function handles Bus Fault exception.
  * @param  None
  * @retval None
  */
void BusFault_Handler(void)
{
  /* Go to infinite loop when Bus Fault exception occurs */
  while (1)
  {
  }
}

/**
  * @brief  This function handles Usage Fault exception.
  * @param  None
  * @retval None
  */
void UsageFault_Handler(void)
{
  /* Go to infinite loop when Usage Fault exception occurs */
  while (1)
  {
  }
}

/**
  * @brief  This function handles SVCall exception.
  * @param  None
  * @retval None
  */
void SVC_Handler(void)
{
}

/**
  * @brief  This function handles Debug Monitor exception.
  * @param  None
  * @retval None
  */
void DebugMon_Handler(void)
{
}

/**
  * @brief  This function handles PendSVC exception.
  * @param  None
  * @retval None
  */
void PendSV_Handler(void)
{
}

/**
  * @brief  This function handles SysTick Handler.
  * @param  None
  * @retval None
  */
void SysTick_Handler(void)
{
  TimingDelay_Decrement();
}

/******************************************************************************/
/*                 STM32F4xx Peripherals Interrupt Handlers                   */
/*  Add here the Interrupt Handler for the used peripheral(s) (PPP), for the  */
/*  available peripheral interrupt handler's name please refer to the startup */
/*  file (startup_stm32f4xx.s).                                               */
/******************************************************************************/

/**
  * @brief  This function handles PPP interrupt request.
  * @param  None
  * @retval None
  */
void EXTI15_10_IRQHandler(void)
{
	 
	if(EXTI->PR & (1<<12))
	{  EXTI->PR |= (1<<12);


	if (on)
	{
	 GPIOB->ODR |= ((1 << 13)|(1 << 15)	);
	 on = 0;
	}
	else
 	{
	GPIOB->ODR &= ~((1 << 13)|(1 << 15)	);
	on = 1;
	}
	}
	
}
void USART2_IRQHandler(void)
{ u8 tmp;

 //  GPIOB->ODR &= ~((1 << 13)|(1 << 15)	);

  preskoc = 0;
tmp = USART_ReceiveData(USART2);
if(interni)
{
 adamove_data = tmp;
interni = 0;
preskoc = 1;
}
if(tmp == '!')
{
interni = 1; 
preskoc = 1;
}
//-------
if(poslat==0 && preskoc ==0)
{
USART_SendData(USART1,tmp);
while(USART_GetFlagStatus(USART1, USART_FLAG_TXE) == RESET);
}
	if (on)
	{
	 GPIOB->ODR |= ((1 << 13)	);
	 on = 0;
	}
	else
 	{
	GPIOB->ODR &= ~((1 << 13)	);
	on = 1;
	}
} 

void USART6_IRQHandler(void)
{ int tmp;
tmp = USART_ReceiveData(USART6);
USART_SendData(USART6,tmp);
}
//***************************
void USART1_IRQHandler(void)
{ u8 tmp;
  GPIOB->ODR &= ~((1 << 15)	);
tmp = USART_ReceiveData(USART1);
USART_SendData(USART2,tmp);
while(USART_GetFlagStatus(USART2, USART_FLAG_TXE) == RESET);
if(tmp == 0xFF)
poslat =1 ;


if (on)
	{
	 GPIOB->ODR |= ((1 << 15)	);
	 on = 0;
	}
	else
 	{
	GPIOB->ODR &= ~((1 << 15)	);
	on = 1;
	}
}      

/**
  * @}
  */ 


/******************* (C) COPYRIGHT 2011 STMicroelectronics *****END OF FILE****/
